require 'openssl'
require 'open-uri'
require 'json'
class GeoLocationUtility

  # Method to initialize instance variables
  def initialize
    @ip_lookup_url= 'http://bot.whatismyipaddress.com'
    @location_lookup_url='http://extreme-ip-lookup.com/json/'
    @city_lookup_url='https://maps.googleapis.com/maps/api/geocode/json?latlng='
  end

# Method to get public IP address of Machine
  def get_ip_address
    get_public_ip = GeoLocationUtility.new
    public_ip=open(get_public_ip.get_ip_lookUp_URL).read
    return public_ip
  end

# Method to get geographical location from IP Address
  def get_geo_location(ip_address)
    location = GeoLocationUtility.new
    #ip_address= location.get_ip_address
    location_json = open(location.get_location_lookUp_URL+ip_address).read
    city=location.get_value_from_json(location_json,'city')

    if(city.eql?(""))
      latitude=location.get_value_from_json(location_json,'lat')
      longitude=location.get_value_from_json(location_json,'lon')
      google_address_json=open(location.get_city_lookUp_URL+latitude+longitude+'&sensor=true', {ssl_verify_mode: 0}).read
      address=get_value_from_json_array(google_address_json,'results','formatted_address')

    else
      country=location.get_value_from_json(location_json,'country')
      region=location.get_value_from_json(location_json,'region')
      address=city+', '+region+', '+country
    end
    return address
  end

# Method to get Ip Lookup URL
  def get_ip_lookUp_URL
    return @ip_lookup_url
  end

# Method to set Ip Lookup URL
  def set_ip_lookUp_URL(ip_lookup_url)
    @ip_lookup_url=ip_lookup_url
  end

# Method to get Geo-Location Lookup URL
  def get_location_lookUp_URL
    return @location_lookup_url
  end

# Method to set Geo-Location Lookup URL
  def set_location_lookUp_URL(location_lookup_url)
    @location_lookup_url=location_lookup_url
  end

# Method to get City Lookup URL
  def get_city_lookUp_URL
    return @city_lookup_url
  end

# Method to set City Lookup URL
  def set_city_lookUp_URL(city_lookup_url)
    @city_lookup_url=city_lookup_url
  end

# Method to get value from given key from given JSON string
  def get_value_from_json (json, key)
    data_hash = JSON.parse(json)
    value=data_hash[key]
    return value
  end

# Method to get value from given key from given JSON array
  def get_value_from_json_array (json, array_name, key)
    data_hash = JSON.parse(json)
    value=data_hash[array_name][0][key]
    return value
  end

end